package com.javaseleniumtemplate.tests.semLote;


import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.dbsteps.DBSteps;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.semLote.RetiradaDeEstoqueNaoControlaLoteFlows;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.semLote.RetiradaDeEstoqueNaoControlaLotePage;
import org.testng.Assert;
import org.testng.annotations.Ignore;
import org.testng.annotations.Test;

public class RetiradaDeEstoqueNaoControlaLoteTests extends TestBase{
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    RetiradaDeEstoqueNaoControlaLoteFlows retiradaDeEstoqueNaoControlaLoteFlows;
    RetiradaDeEstoqueNaoControlaLotePage retiradaDeEstoqueNaoControlaLotePage;


    @Test (description = "Est-32")
    @Ignore
    public void EfetuarRetiradaDeEstoque(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        retiradaDeEstoqueNaoControlaLoteFlows = new RetiradaDeEstoqueNaoControlaLoteFlows();
        retiradaDeEstoqueNaoControlaLotePage = new RetiradaDeEstoqueNaoControlaLotePage();


        //Parameteres_Lançamento:
        String quantidade = "3";
        String cmpDesc = "Teste Automatizado Retirada de Estoque";
        String descProduto = "SUMO DE LIMAO - CX12 500ML";
        String descAlmoxarifado = "HELA MATRIZ";
        String campoSetor = "Administrativo";
        String DescCampoLote = "025/50";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String valorDevolvido = "1";
        String campoRetirada = "CONSUMO DE PRODUÇÃO";
        String quantidadeBanco = "18";
        String quantidadeSolicitada = "3";
        String quantidadeDevolvida = "1";
        String quantidadeRestante = "2";
        String valorUnitarioLancado = "1.2";






        //Rotinas:
        loginFlows.efetuarLogin();
       // mainFlows.AcessandoTrocaUnidadeNaoControlaLote();
        mainFlows.AcessandoRetiradaDeEstoque();
        retiradaDeEstoqueNaoControlaLoteFlows.aplicarFiltro(descUnidade,descAlmoxarifado);
        retiradaDeEstoqueNaoControlaLoteFlows.AdicionarRetiradaEstoque(cmpDesc,descProduto,quantidade,descAlmoxarifado,DescCampoLote,valorDevolvido, campoSetor, campoRetirada);


        //Banco tela de retirada
       String numeroLancamento = retiradaDeEstoqueNaoControlaLotePage.retornaNumeroLancamento();
       Assert.assertTrue(DBSteps.retornaQuatidadeEstoque(numeroLancamento).contains(quantidadeBanco));

        String valorSolicitado = retiradaDeEstoqueNaoControlaLotePage.retornaQuantidadeSolicitada();
        Assert.assertTrue(DBSteps.retornaQuantidadeSolicitadaEstoque(valorSolicitado).contains(quantidadeSolicitada));

        String devolucaoEstoque = retiradaDeEstoqueNaoControlaLotePage.retornaQuantidadeDevolvida();
         Assert.assertTrue(DBSteps.retornaQuantidadeDevolvidaEstoque(devolucaoEstoque).contains(quantidadeDevolvida));

       String restanteEstoque = retiradaDeEstoqueNaoControlaLotePage.retornaQuantidadeRestante();
        Assert.assertTrue(DBSteps.retornaQuantidadeRestanteEstoque(restanteEstoque).contains(quantidadeRestante));

        Assert.assertTrue(DBSteps.retornaValorUnitarioLancadoEstoque(numeroLancamento).contains(valorUnitarioLancado));




    }


    @Test(description = "Est-33")
    @Ignore
    public void EditarRetiradaEstoqueNaoControlaLote(){
        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        retiradaDeEstoqueNaoControlaLoteFlows = new RetiradaDeEstoqueNaoControlaLoteFlows();
        retiradaDeEstoqueNaoControlaLotePage = new RetiradaDeEstoqueNaoControlaLotePage();

        //Parametres
        String descAlmoxarifado = "HELA MATRIZ";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String campoEditado ="Deletar";

        //Rotine:
        loginFlows.efetuarLogin();
        //mainFlows.AcessandoTrocaUnidadeNaoControlaLote();
        mainFlows.AcessandoRetiradaDeEstoque();
        retiradaDeEstoqueNaoControlaLoteFlows.aplicarFiltro(descUnidade, descAlmoxarifado);
        retiradaDeEstoqueNaoControlaLoteFlows.EditarRetiradaEstoque(campoEditado);

    }
    @Test(description = "Est-34")
    @Ignore
    public void ExcluirRetiradaEstoqueNaoControlaLote(){
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        retiradaDeEstoqueNaoControlaLoteFlows = new RetiradaDeEstoqueNaoControlaLoteFlows();
        retiradaDeEstoqueNaoControlaLotePage = new RetiradaDeEstoqueNaoControlaLotePage();

        //Parametres
        String descAlmoxarifado = "HELA MATRIZ";
        String descUnidade = "HELA INGREDIENTES BRASIL";


        //rotine
        loginFlows.efetuarLogin();
       // mainFlows.AcessandoTrocaUnidadeNaoControlaLote();
        mainFlows.AcessandoRetiradaDeEstoque();
       retiradaDeEstoqueNaoControlaLoteFlows.aplicarFiltro(descUnidade, descAlmoxarifado);
        retiradaDeEstoqueNaoControlaLoteFlows.ExcluirRetiradaEstoque();


    }

@Test(description = "Est-00")
@Ignore
    public void TesteBanco(){

    mainPage = new MainPage();
    loginFlows = new LoginFlows();
    mainFlows = new MainFlows();
    retiradaDeEstoqueNaoControlaLoteFlows = new RetiradaDeEstoqueNaoControlaLoteFlows();
    retiradaDeEstoqueNaoControlaLotePage = new RetiradaDeEstoqueNaoControlaLotePage();




    //Rotinas:
    // loginFlows.efetuarLogin();
    String ntlancestq = "0000007209";
    String teste =  DBSteps.retornaQuantidadeRestanteEstoque(ntlancestq);
    System.out.println(teste);




}


}